!!Padico_Timing!! 	  padico_timing_get_tick(&global_paco_context_ptr->_ticks[0]);

!!asynch_yes!!  void** arg_rcp = (void** ) arg;
!!asynch_yes!!  @@PACKAGE_NAME@@::PaCO_parallel_layer_@@INTERFACE_NAME@@ * client = (@@PACKAGE_NAME@@::PaCO_parallel_layer_@@INTERFACE_NAME@@ * ) arg_rcp[0];
!!asynch_yes!!  @@ARGS_DECLARATION@@
!!asynch_yes!!  @@OPERATION_CLASS_NAME@@ * @@METHOD_NAME@@_ptr = client->@@METHOD_NAME@@_ptr;
!!server!!  @@METHOD_NAME@@_ptr->my_mutex->lock();
!!asynch_yes!! @@METHOD_NAME@@_ptr->my_mutex3->lock();
  @@INIT_DIS_LIB@@

   // local variables
  const unsigned      myRank = @@METHOD_NAME@@_ptr->myRank;
  const long     _current_id = @@METHOD_NAME@@_ptr->_current_id;

  paco_comScheduling* my_comScheduling  = @@METHOD_NAME@@_ptr->my_comScheduling;
!!assert!!  assert(my_comScheduling);

  PaCO_operation::_com_info_t*  _com_info     = @@METHOD_NAME@@_ptr->getComMemoryId(_current_id);
  paco_comSchedule*       _schedule_info = my_comScheduling->getSchedule(_current_id);
 
!!client!!  unsigned srvTotal = @@METHOD_NAME@@_ptr->serveur_topo_aller.total;
!!server!!  unsigned srvTotal = @@METHOD_NAME@@_ptr->serveur_topo_retour.total;
  

!!Info_Client!! std::cerr << "[INFO] id: "<<_current_id<<", cm: "<<_com_info<<", cs: "<<_schedule_info<<endl;

   // Determine what we have to compute
   unsigned ** com_matrix;
   void *** info_vector;

!!Padico_Timing!! 	  padico_timing_get_tick(&global_paco_context_ptr->_ticks[1]);

   // compute communication matrix ?
   if ((_current_id == -1) || (_com_info == NULL))
    {
      !!Info_Client!! std::cerr << "[INFO] computing commnucation matrix\n";
      // Allocating & initializing com matrix
      com_matrix = new unsigned *[@@METHOD_NAME@@_ptr->mytopo.total];
      unsigned* com_area = (unsigned*)calloc(@@METHOD_NAME@@_ptr->mytopo.total*srvTotal, sizeof(unsigned)); // ZEROED !
      if (com_area == NULL) {
	cerr << "Can not allocate memory of size " << @@METHOD_NAME@@_ptr->mytopo.total*srvTotal*sizeof(unsigned) << endl;
      abort();
      }
      for(unsigned i=0; i<@@METHOD_NAME@@_ptr->mytopo.total; i++)
	{
	  com_matrix[i] = &com_area[i*srvTotal];
	}

      // Allocating & initializing info matrix
      info_vector = new void **[srvTotal];
      void ** info_area = new void*[srvTotal*@@ARG_NUMBER@@]; // do not need to be zeroed
      if (info_area == NULL) {
	cerr << "Can not allocate memory of size " << @@ARG_NUMBER@@*srvTotal*sizeof(unsigned) << endl;
	abort();
      }
      for(unsigned i=0; i<srvTotal; i++)
	{
	  info_vector[i] = &info_area[i*@@ARG_NUMBER@@];
	}

      // Allocating & initializing com info 
      _com_info = new PaCO_operation::_com_info_t();
      _com_info->com_matrix = com_matrix;
      _com_info->info_vector = info_vector;

      // Saving the communication matrix into the paco operation object
      if (_current_id>=0)
	{
	  !!Debug_Client!!  cerr<<" saving communication for memory id "<<_current_id<<endl;
	  @@METHOD_NAME@@_ptr->_com_info_map[_current_id] = _com_info;
	}

      PieceToSend* com_vector;
      unsigned     com_vector_size;

      @@CONS_LOCAL_COMM_MATRIX@@
	
      //  propagate information (usually an All-to-All operation)      
      if (@@METHOD_NAME@@_ptr->mytopo.total > 1)
	my_comScheduling->propageComMatrix(@@METHOD_NAME@@_ptr, com_matrix);
    }
    else // -> let reuse memory :)
    {
      !!Info_Client!! cerr<<"[INFO] using communication memory "<<_current_id<<endl;
      com_matrix = _com_info->com_matrix;
      info_vector = _com_info->info_vector;
    } 

!!Padico_Timing!! 	  padico_timing_get_tick(&global_paco_context_ptr->_ticks[2]);


    // compute communication schedule ?
    if ((_current_id == -1) || (_schedule_info == NULL))	  
    {      
      // Building the bigraph : special case : local info to be added to local rooted edges
      // **SHOULD BE** AVOIDED IF WE STORE _g in PaCO_OPERATION and nore com_matrix      
      !!Info_Client!! std::cerr << "[INFO] computing scheduling\n";

      // ARE WE SURE IT IS ALWAYS topo_aller AND IT IS NOT topo_retour ???
      _schedule_info = my_comScheduling->computeScheduling(myRank, 
							   &@@METHOD_NAME@@_ptr->mytopo, &@@METHOD_NAME@@_ptr->serveur_topo_aller,
							   com_matrix, info_vector);

      // Saving the schedule matrix into the paco operation object
      if (_current_id>=0)
	{
	  !!Debug_Client!!  cerr<<" saving schedule for memory id "<<_current_id<<endl;
	  my_comScheduling->setSchedule(_current_id, _schedule_info);
	}

      !!Debug_Client!! unsigned int debug_phases = _schedule_info->getNbPhases();
      !!Debug_Client!! cerr<<"#phase : " << debug_phases<<endl;
      !!Debug_Client!! for(unsigned int i = 0; i < debug_phases; i++) 
      !!Debug_Client!! {
	!!Debug_Client!!   cerr<<"phase number : " << (i+1) << "  #element: "<< _schedule_info->getElementPhase(i) <<endl;
      !!Debug_Client!!   for(unsigned int j = 0 ; j < _schedule_info->getElementPhase(i) ; j++)
      !!Debug_Client!!     {
      !!Debug_Client!!       cerr << "X" << _schedule_info->getSrc(i,j) << " -- Y" << _schedule_info->getDst(i,j) << " : " << _schedule_info->getSize(i,j) << endl;	
      !!Debug_Client!!     }
      !!Debug_Client!! }
    }
   else
    {
      !!Info_Client!!  cerr<<"[INFO] using schedule memory "<<_current_id<<endl;
    }
  
!!Padico_Timing!! 	  padico_timing_get_tick(&global_paco_context_ptr->_ticks[3]);

!!client!!  @@OUT_ARGS_INIT@@
!!client!!  @@METHOD_NAME@@_ptr->local_return_layer->@@METHOD_NAME@@_init(@@CALLBACK_ARGS_INIT@@);

!!Padico_Timing!! 	  padico_timing_get_tick(&global_paco_context_ptr->_ticks[4]);

  unsigned int phases = _schedule_info->getNbPhases();;
  for(unsigned int i = 0; i < phases; i++) 
    {
      !!Debug_Client!! cerr << "** Phase "<<i<<endl;
      for(unsigned int j = 0 ; j < _schedule_info->getElementPhase(i) ; j++)
	{
	  if (_schedule_info->getSrc(i,j) == myRank)
	    {
	      !!Debug_Client!! cerr << "Node " << myRank << " sending " <<  _schedule_info->getSize(i,j) << endl;
	      long data_size = _schedule_info->getSize(i,j);
	      //	      long sauv_size_data = data_size;
	      bool end_arg = false;
	      int counter = 0;
	      @@GET_DATA@@
	     !!asynch_no!!  real_stubs[_schedule_info->getDst(i,j)]->@@METHOD_NAME_PARALLEL@@(@@FINAL_ARGS@@);
	     !!asynch_yes!! client->real_stubs[_schedule_info->getDst(i,j)]->@@METHOD_NAME_PARALLEL@@(@@FINAL_ARGS@@);
	    }
	}
      @@METHOD_NAME@@_ptr->my_com->paco_barrier();
    }

!!Padico_Timing!! 	  padico_timing_get_tick(&global_paco_context_ptr->_ticks[5]);


!!client!!  @@METHOD_NAME@@_ptr->local_return_layer->@@METHOD_NAME@@(@@CALLBACK_ARGS@@);
!!client!!  @@FINAL_OUT_ARGS@@
!!client!!  @@METHOD_NAME@@_ptr->my_com->paco_barrier();

!!Padico_Timing!! 	  padico_timing_get_tick(&global_paco_context_ptr->_ticks[6]);

  @@FREE_ALL@@
!!server!! @@METHOD_NAME@@_ptr->my_mutex->unlock();
!!asynch_yes!!  @@METHOD_NAME@@_ptr->my_mutex3->unlock();

!!Padico_Timing!! 	  padico_timing_get_tick(&global_paco_context_ptr->_ticks[7]);
