# Written by Andre Ribes 2002
#!/usr/bin/env python

import sys
import os
import string
import base
import complex
import Argument

def GenerateClientStub(file_source_h, file_source_cc, configfile, base_name, modes, debug):

    continu               = 'true'
    interface_number      = 0
    interface_name        = ''
    package_name          = ''
    package_name_complete = ''
    
    while continu == 'true':
        interface_number = interface_number + 1
        interface_name = base.search_macro(configfile,'INTERFACE_NAME_' + str(interface_number))
        package_name = base.search_macro(configfile,'PACKAGE_NAME_' + str(interface_number))
        package_name_file = ''
        package_name_complete = ''
        if package_name != '':
            package_name = package_name[2:]
            # search and replace
            package_name_file = package_name
            package_name_file = string.replace(package_name_file, '::', '_')
            package_name_complete = package_name + '::'

        if interface_name == 'null':
            continu = 'false'
        else:
	    h_file_name  = base_name + '_' + package_name_file + '_' + interface_name + '_client.h'
	    cc_file_name = base_name + '_' + package_name_file + '_' + interface_name + '_client.cc'

            GenerateClientStubGeneric(interface_name, package_name, package_name_complete, file_source_h, h_file_name, cc_file_name, configfile, base_name, 'client', modes, debug)

def GenerateClientStub_Return(file_source_h, file_source_cc, configfile, base_name, modes, debug):
    
    interface_number      = 0
    continu               = 'true'
    interface_number      = 0
    interface_name        = ''
    package_name          = ''
    package_name_complete = ''
    
    while continu == 'true':
        interface_number = interface_number + 1
        interface_name = base.search_macro(configfile,'INTERFACE_NAME_' + str(interface_number))
        package_name = base.search_macro(configfile,'PACKAGE_NAME_' + str(interface_number))
        package_name_file = ''
        package_name_complete = ''
        if package_name != '':
            package_name = package_name[2:]
            # search and replace
            package_name_file = package_name
            package_name_file = string.replace(package_name_file, '::', '_')
        if interface_name == 'null':
            continu = 'false'
        else:
	    h_file_name  = base_name + '_' + package_name_file + '_' + interface_name[:-7] + '_server.h'
	    cc_file_name = base_name + '_' + package_name_file + '_' + interface_name[:-7] + '_server.cc'
            
            GenerateClientStubGeneric(interface_name, package_name, package_name_complete, file_source_h, h_file_name, cc_file_name, configfile, base_name, 'server', modes, debug)
            
def GenerateClientStubGeneric(interface_name, package_name, package_name_complete, file_source_h, h_file_name, cc_file_name, configfile, base_name, side, modes, debug):

    chemin = os.environ['PACOPATH']    
    orb = base.search_macro(configfile,'ORB')
    search_macro_package_name = ''
    package_name_to_insert = ''
    if package_name != '':
        package_name_to_insert = package_name + '::'
        search_macro_package_name = '::' + package_name
    modes.append(side)
    ##################################################################################################################
    ##################################################################################################################
    # .h file generation
    
    base.concanate_files(h_file_name, chemin + "/GenFiles/Client/ClientParallelStub.h", modes)
    #
    #  Needs : @@NAMESPACE@@, @@NAMESPACE_END@@, @@INTERFACE_NAME@@, @@ABSTRACT_METHODS@@, @@OBJECTS@@, @@METHODS_H@@
    #
    namespace        = ''
    namespace_end    = ''
    abstract_methods = ''
    methods_h        = ''
    objects          = ''
    method_class     = ''
    
    method_abstract_class = complex.search_method(file_source_h, package_name, interface_name, orb, "ABSTRACT")
    for counter in range(len(method_abstract_class)):
        abstract_methods = abstract_methods + method_abstract_class[counter]
    method_class = complex.search_method(file_source_h, package_name, interface_name, orb, "CLIENT")
    for counter in range(len(method_class)):
        methods_h = methods_h + method_class[counter]
    if package_name != '':
        package_name_temp = package_name
        index = 0
        while index != -1:
            index = string.find(package_name_temp, "::")
            if index == -1:
                namespace = namespace + "namespace " + package_name_temp + " {\n"
                namespace_end = namespace_end + "};\n"
            else:
                namespace = namespace + "namespace " + package_name_temp[:index] + " {\n"
                namespace_end = namespace_end + "};\n"
                package_name_temp =  package_name_temp[index+2:]
    if side == 'client':
        objects = package_name_to_insert + "global_paco_context * global_paco_context_ptr;\n"
    else :
        objects = package_name_to_insert + "global_paco_context_server * global_paco_context_ptr;\n"
    for counter in range(len(method_class)) :
        result = complex.decompose_method(method_class[counter], 'c++')
        return_method    = result.pop()
        method_name      = result.pop()
        arguments_method = result.pop()
        type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name)
        if type == 'distributed' :
            if side == 'client':
                objects = objects + '  ' + package_name_to_insert + method_name + "_context * " + method_name + "_ptr;\n"
            else :
                objects = objects + '  ' + package_name_to_insert + method_name + "_server_context * " + method_name + "_ptr;\n"
                
    base.StringToString(h_file_name, '@@NAMESPACE@@', namespace)
    base.StringToString(h_file_name, '@@NAMESPACE_END@@', namespace_end)
    base.StringToString(h_file_name, '@@INTERFACE_NAME@@', interface_name)
    base.StringToString(h_file_name, '@@ABSTRACT_METHODS@@', abstract_methods)
    base.StringToString(h_file_name, '@@OBJECTS@@', objects)
    base.StringToString(h_file_name, '@@METHODS_H@@', methods_h)
        
    ##################################################################################################################
    ##################################################################################################################


    ##################################################################################################################
    ##################################################################################################################
    # .cc file generation
    
    base.concanate_files(cc_file_name,  chemin + "/GenFiles/Client/ClientParallelStub.cc", modes)
    #
    # Need : @@PACKAGE_NAME_COMPLETE_@@, @@INTERFACE_NAME@@, @@CONTEXT@@, @@METHODS_CC@@, @@METHODS_OUTPUT_CC@@, @@CONS_PARALLEL_LAYER@@, @@DES_PARALLEL_LAYER@@
    #
    context               = ''
    methods_cc            = ''
    methods_output_cc     = ''
    cons_parallel_layer   = ''
    des_parallel_layer    = ''
    
    context = base.addFileToString(context, chemin + "/GenFiles/Client/ClientParallelGetContext.cc", modes)
    # Need @@METHOD_NAME@@
    context = base.string_configuration(context, "@@METHOD_NAME@@", "global_paco_context")
    cons_parallel_layer = base.addFileToString(cons_parallel_layer, chemin + "/GenFiles/Client/ClientParallelStubConstructor.cc", modes)
    # Need @@PACKAGE_NAME@@
    cons_parallel_layer = base.string_configuration(cons_parallel_layer, "@@PACKAGE_NAME@@", package_name_to_insert)
    des_parallel_layer = base.addFileToString(des_parallel_layer, chemin + "/GenFiles/Client/ClientParallelStubDestructor.cc", modes)    
    for counter in range(len(method_class)) :
        result = complex.decompose_method(method_class[counter], 'c++')
        return_method     = result.pop()
        method_name       = result.pop()
        arguments_method  = result.pop()
        arg_number        = complex.get_arguments_number(method_class[counter])
        methods_cc        = methods_cc + "@@METHODS_CC_" + str(counter) + "@@\n"
        methods_output_cc = methods_output_cc + "@@METHODS_OUTPUT_CC_" + str(counter) + "@@\n"
        type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name)
        if type == 'distributed' :
            context = base.addFileToString(context, chemin + "/GenFiles/Client/ClientParallelGetContext.cc", modes)
            context = base.string_configuration(context, "@@METHOD_NAME@@", method_name)
            cons_parallel_layer = base.addFileToString(cons_parallel_layer, chemin + "/GenFiles/Client/ClientParallelStubConstructorContext.cc", modes)
            # Need @@METHOD_NAME@@, @@ARG_NUMBER@@, @@PACKAGE_NAME@@
            cons_parallel_layer = base.string_configuration(cons_parallel_layer, "@@PACKAGE_NAME@@", package_name_to_insert)
            cons_parallel_layer = base.string_configuration(cons_parallel_layer, "@@METHOD_NAME@@", method_name)
            cons_parallel_layer = base.string_configuration(cons_parallel_layer, "@@ARG_NUMBER@@", arg_number)
            des_parallel_layer = base.addFileToString(des_parallel_layer, chemin + "/GenFiles/Client/ClientParallelStubDestructorContext.cc", modes)
            # Need @@METHOD_NAME@@
            des_parallel_layer = base.string_configuration(des_parallel_layer, "@@METHOD_NAME@@", method_name)
            
    base.StringToString(cc_file_name, '@@METHODS_OUTPUT_CC@@', methods_output_cc)
    base.StringToString(cc_file_name, '@@PACKAGE_NAME_COMPLETE_@@', package_name_to_insert)
    base.StringToString(cc_file_name, '@@INTERFACE_NAME@@', interface_name)
    base.StringToString(cc_file_name, '@@CONTEXT@@', context)
    base.StringToString(cc_file_name, '@@METHODS_CC@@', methods_cc)
    base.StringToString(cc_file_name, '@@METHODS_OUTPUT_CC@@', methods_output_cc)
    base.StringToString(cc_file_name, '@@CONS_PARALLEL_LAYER@@', cons_parallel_layer)
    base.StringToString(cc_file_name, '@@DES_PARALLEL_LAYER@@', des_parallel_layer)
    # Now we need to configure METHODS* and METHODS_OUTPUT*
    # We don't implement OuputManager so the methods are empty
    
    # OuputManager ...
    for counter in range(len(method_class)) :
        result = complex.decompose_method(method_class[counter], 'c++')
        return_method     = result.pop()
        method_name       = result.pop()
        arguments_method  = result.pop()
        arguments_method  = arguments_method[:-2] # - ;/n
        
        class_name  = 'PaCO_output_stub_' + interface_name
        method_code = ''
        method_code = base.addFileToString(method_code, chemin + "/GenFiles/Base/GenOperation.cc", modes)
        # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
        method_code = base.string_configuration(method_code, "@@RETURN@@", return_method)                
        method_code = base.string_configuration(method_code, "@@PACKAGE_NAME@@", package_name_to_insert)
        method_code = base.string_configuration(method_code, "@@CLASS_NAME@@", class_name)
        method_code = base.string_configuration(method_code, "@@NAME_OPERATION_COMPLETE@@", method_name + arguments_method)
        method_code = base.string_configuration(method_code, "@@CODE@@", "")
        
        base.StringToString(cc_file_name, '@@METHODS_OUTPUT_CC_' + str(counter) + '@@', method_code)
        
    # PaCO++ layer
    for counter in range(len(method_class)) :
        result = complex.decompose_method(method_class[counter], 'c++')
        return_method     = result.pop()
        method_name       = result.pop()
        arguments_method  = result.pop()
        arguments_method  = arguments_method[:-2] # - ;/n

        type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name)
        if type != 'distributed':
            if return_method == 'void' :
                modes.append('no_return')
            else :
                modes.append('return')
            class_name  = 'PaCO_parallel_layer_' + interface_name
            code = ''
            method_code = ''
            method_code = base.addFileToString(method_code, chemin + "/GenFiles/Base/GenOperation.cc", modes)
            # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
            method_code = base.string_configuration(method_code, "@@RETURN@@", return_method)
            method_code = base.string_configuration(method_code, "@@PACKAGE_NAME@@", package_name_to_insert)
            method_code = base.string_configuration(method_code, "@@CLASS_NAME@@", class_name)
            method_code = base.string_configuration(method_code, "@@NAME_OPERATION_COMPLETE@@", method_name + arguments_method)
            
            code = base.addFileToString(code, chemin + '/GenFiles/Client/CSequentialMethod.cc', modes)
            # Need : METHOD_NAME, ARGS
            args = ''
            arguments_temp = arguments_method
            while arguments_temp != '':
                arg = complex.researchArgName(arguments_temp)
                arg_type = arg.pop()
                arg_name = arg.pop()
                arguments_temp = arg.pop()
                if arg_type != '':
                    if args == '' :
                        args = arg_name
                    else :
                        args = args + ', ' + arg_name 
            code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
            code = base.string_configuration(code, '@@ARGS@@', args)
            method_code = base.string_configuration(method_code, "@@CODE@@", code)
            base.StringToString(cc_file_name, '@@METHODS_CC_' + str(counter) + '@@', method_code)
            if return_method == 'void' :
                modes.remove('no_return')
            else :
                modes.remove('return')
                
        #        if type == 'distributed' :
        else :
            # If the method is a parallel oneway method we create a new method
            # to be able to perform real asynchroneous invocation
            oneway = 'no'
            if side == 'client' :
                oneway = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_ONEWAY')
            if oneway == 'no':
                class_name  = 'PaCO_parallel_layer_' + interface_name
                code = ''
                method_code = ''
                method_code = base.addFileToString(method_code, chemin + "/GenFiles/Base/GenOperation.cc", modes)
                # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                method_code = base.string_configuration(method_code, "@@RETURN@@", "void")
                method_code = base.string_configuration(method_code, "@@PACKAGE_NAME@@", package_name_to_insert)
                method_code = base.string_configuration(method_code, "@@CLASS_NAME@@", class_name)
                method_code = base.string_configuration(method_code, "@@NAME_OPERATION_COMPLETE@@", method_name + arguments_method)

                # And now the parallel management code !!!!!
                if side == 'client' :
                    modes.append('client')
                    code = Argument.get_client_dis_code(package_name, arguments_method, interface_name, method_name, file_source_h, configfile, modes, debug)
                    modes.remove('client')
                if side == 'server' :
                    modes.append('server')
                    code = Argument.get_client_dis_code(package_name, arguments_method, interface_name, method_name, file_source_h, configfile, modes, debug)
                    modes.remove('server')
                method_code = base.string_configuration(method_code, "@@CODE@@", code)
                base.StringToString(cc_file_name, '@@METHODS_CC_' + str(counter)+ '@@', method_code)
            else :
                base.StringToString(cc_file_name, '@@METHODS_CC_' + str(counter) + '@@', '@@TOTO@@\n@@METHODS_CC_' + str(counter) + '@@')

                # Part 1 : parallel method
                method_code = ''
                method_code = base.addFileToString(method_code, chemin + "/GenFiles/Base/GenMethod.cc", modes)
                # Need @@RETURN@@, @@NAME_OPERATION_COMPLETE@@, @@CODE@@
                code = ''
                if side == 'client' :
                    modes.append('client')
                    code = Argument.get_client_dis_code(package_name, arguments_method, interface_name, method_name, file_source_h, configfile, modes, debug, "yes")
                    modes.remove('client')
                if side == 'server' :
                    modes.append('server')
                    code = Argument.get_client_dis_code(package_name, arguments_method, interface_name, method_name, file_source_h, configfile, modes, debug, "yes")
                    modes.remove('server')
                name_operation_complete = package_name + '_' + interface_name + '_' + method_name + '_client_thread(void * arg)'
                method_code = base.string_configuration(method_code, "@@RETURN@@", "void *")
                method_code = base.string_configuration(method_code, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
                method_code = base.string_configuration(method_code, "@@CODE@@", code)
                base.StringToString(cc_file_name, '@@TOTO@@', method_code)

                # Part 2 : parallel operation
                class_name  = 'PaCO_parallel_layer_' + interface_name
                code = ''
                method_code = ''
                method_code = base.addFileToString(method_code, chemin + "/GenFiles/Base/GenOperation.cc", modes)
                # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                method_code = base.string_configuration(method_code, "@@RETURN@@", "void")
                method_code = base.string_configuration(method_code, "@@PACKAGE_NAME@@", package_name_to_insert)
                method_code = base.string_configuration(method_code, "@@CLASS_NAME@@", class_name)
                method_code = base.string_configuration(method_code, "@@NAME_OPERATION_COMPLETE@@", method_name + arguments_method)
                # And now the parallel management code !!!!!
                if side == 'client' :
                    modes.append('client')
                    code = Argument.get_client_thread_dis_code(package_name, arguments_method, interface_name, method_name, file_source_h, configfile, modes, debug)
                    modes.remove('client')
                if side == 'server' :
                    modes.append('server')
                    code = Argument.get_client_thread_dis_code(package_name, arguments_method, interface_name, method_name, file_source_h, configfile, modes, debug)
                    modes.remove('server')
                method_code = base.string_configuration(method_code, "@@CODE@@", code)
                base.StringToString(cc_file_name, '@@METHODS_CC_' + str(counter) + '@@', method_code)
    modes.remove(side)

