# Written by Andre Ribes 2002
#!/usr/bin/env python


import sys
import base
import os
import tempfile
import string
    
def generate_inputmanager(fichier_source_h, fichier_implementation_h, fichier_implementation_cc, configfile):

    # init
    chemin = os.environ['PACOPATH']
    fichier_conf_temp = open('temp_file_conf', 'wr')
    orb = base.search_macro(configfile,'ORB')
    numero_interface = 0
    continu = 'true'
    fichier_h = open(fichier_implementation_h,'wr')
    fichier_h.close()
    fichier_cc = open(fichier_implementation_cc,'wr')
    fichier_cc.close()
    
    if orb == 'OMNIORB3':
        while continu == 'true':
            numero_interface = numero_interface + 1
            name_interface = base.search_macro(configfile,'INTERFACE_NAME_' + str(numero_interface))
            if name_interface == 'null':
                continu = 'false'
            else:                
                name_class_search = '_impl_' + name_interface
                insert_method_class = base.search_method(fichier_source_h,name_class_search,'OMNIORB3')

                # Ajout dans le fichier de configuration temporaire le nom de la classe de base
                package_name = base.search_macro(configfile,'PACKAGE_NAME_' + str(numero_interface))
                name_class = ''
                if package_name != '':
                    name_class = 'NAME_CLASS=' + 'POA_'+ package_name[2:] + '::' + name_interface + '\n'
                else:
                    name_class = 'NAME_CLASS=' + 'POA_'+ name_interface + '\n'
                fichier_conf_temp.write(name_class)
                fichier_conf_temp.write('NAME_INTERFACE=' + name_interface + '\n')
                fichier_conf_temp.write('FILE=' + fichier_source_h +'\n')
                # Ajout dans le fichier de configuration les noms des methodes
                nombre = 0
                chaine_finale = ''
                for counter in range(len(insert_method_class)):
                    nombre = nombre + 1
                    s = 'INSERT_METHOD_' +str(nombre)+ '='+ insert_method_class[counter] + '\n'   
                    chaine_finale = chaine_finale + 'INSERT_METHOD_' + str(nombre) + '\n'
                    fichier_conf_temp.write(s)
                fichier_conf_temp.flush() 

                # Creation du fichier .hh
                # Configuration du fichier generique
                # ajout d'une ligne par methode
                # Pas bien !!!
                base.replace_string(chemin + '/ORB/OmniORB3/gen/InputManagerGen.hh',fichier_implementation_h,'INSERT_METHOD',chaine_finale)
                base.file_configuration(fichier_implementation_h,'temp_file_conf') 

                # Creation du fichier .cc
                base.replace_string(chemin + '/ORB/OmniORB3/gen/InputManagerGen.cc',fichier_implementation_cc,'NAME_FILE_H',fichier_implementation_h)

                # recuperation des informations de chaque methode
                for counter2 in range(len(insert_method_class)):
                    if counter2 != 0:
                        method_temp = open('method_temp', 'wr')
                        chaine = insert_method_class[counter2]
                        fin_virtual = string.find(chaine,'virtual ')
                        chaine = chaine[fin_virtual+8:]
                        fin_return = string.find(chaine,' ')
                        s = 'RETURN' + '=' + chaine[:fin_return] + '\n'   
                        method_temp.write(s)
                        fin_def = string.find(chaine,';')
                        s = 'METHOD_NAME' + '=' + chaine[fin_return+1:fin_def] + '\n'
                        method_temp.write(s)
                        method_temp.close()
                        if chaine[:fin_return] == 'void':
                            base.concanate_files(fichier_implementation_cc,chemin + '/ORB/OmniORB3/gen/InputManagerFonctionGen1.cc')
                        else:
                            base.concanate_files(fichier_implementation_cc,chemin + '/ORB/OmniORB3/gen/InputManagerFonctionGen2.cc')
                        base.file_configuration(fichier_implementation_cc,'method_temp')
                        os.remove('method_temp')
                method_temp = open('method_temp', 'wr')
                s = 'NAME_INTERFACE' + '=' + name_interface + '\n'
                method_temp.write(s)
                method_temp.close()
                base.file_configuration(fichier_implementation_cc,'method_temp')
                os.remove('method_temp')
    os.remove('temp_file_conf')

def patch_client_stub(fichier_source_h, fichier_source_cc, configfile):

    chemin = os.environ['PACOPATH']
    orb = base.search_macro(configfile,'ORB')
    numero_interface = 0
    continu = 'true'
    # On commence par inclure la chaine suivante a cote de PaCO++.hh
    toto = '#include <PaCO++.hh>\n#include <PaCO++_src.hh>\n'
    # recopie du fichier
    fichier_copie = open('fichier_copie','wr')
    fichier = open(fichier_source_h,'r')
    for s2 in fichier.readlines():
        fichier_copie.write(s2)
    fichier.close()
    fichier_copie.close()
    base.replace_string('fichier_copie',fichier_source_h,'#include <PaCO++.hh>',toto)
    os.remove('fichier_copie')
    if orb == 'OMNIORB3':
        while continu == 'true':
            numero_interface = numero_interface + 1
            name_interface = base.search_macro(configfile,'INTERFACE_NAME_' + str(numero_interface))
            if name_interface == 'null':
                continu = 'false'
            else:
                # Recherche dans le fichier de configuration tous les methodes
                # distribuees de l'interface courante
                name_class_search = '_impl_' + name_interface
                insert_method_class = base.search_method(fichier_source_h,name_class_search,'OMNIORB3')

                # Configuration du stub pour chaque methode
                for counter in range(len(insert_method_class)):
                    if counter != 0:
                        # elimination du virtual
                        chaine = insert_method_class[counter]
                        fin_virtual = string.find(chaine,'virtual ')
                        chaine = chaine[fin_virtual+8:]

                        # pt dans le nom
                        fin_return = string.find(chaine,' ')
                        fin_def = string.find(chaine,';')
                        fin_nom = string.find(chaine,'(')

                        # differentes chaines
                        retour =  chaine[:fin_return]
                        nom_methode_complet = chaine[fin_return+1:fin_def]
                        nom_methode_simple = chaine[fin_return+1:fin_nom]
                        arguments = chaine[fin_nom:]
                        
                        # identification du type de la methode
                        type = base.search_macro(configfile,'TYPE_' + name_interface + '_' + nom_methode_simple)
                        ########### On ne patche que les methodes parallles !!! ###########################
                        if type == 'distributed':
                            
                            ##############################################################
                            # 1 etape : Configuration generale
                            # Insertion d'une structure specifique a la methode
                            # Insertion dans le fichier_source_h de la structure
                            base.insert_code_h(fichier_source_h, chemin + '/ORB/OmniORB3/gen/StructClientgen.hh', '_objref_' + name_interface)
                            fichier_copie = open('fichier_copie','wr')
                            fichier_source_hh = open(fichier_source_h,'r')
                            for line in fichier_source_hh.readlines():
                                fichier_copie.write(line)
                            fichier_copie.close()
                            fichier_source_hh.close()
                            base.replace_string('fichier_copie',fichier_source_h, 'class _objref_' + name_interface + ' :','class _objref_' + name_interface + '_PaCO;\n class _objref_' + name_interface + ' :')
                            os.remove('fichier_copie')
                            # configuration de la structure
                            fichier_config_temp =  open('fichier_config_temp','wr')
                            s = 'INTERFACE_NAME=' + name_interface + '\n'
                            fichier_config_temp.write(s)
                            s = 'METHOD_NAME=' + nom_methode_simple + '\n'
                            fichier_config_temp.write(s)
                            fichier_config_temp.close()
                            base.file_configuration(fichier_source_h,'fichier_config_temp')
                            os.remove('fichier_config_temp')

                            # Insertion dans le fichier_source_cc de l'init de la struture et de la destruction
                            base.insert_code_cc(fichier_source_cc, chemin + '/ORB/OmniORB3/gen/clientconstructorgen.cc', '_objref_' + name_interface + '::_objref_' + name_interface)
                            # base.insert_code_cc(fichier_source_cc, chemin + '/ORB/OmniORB3/gen/ClientDestructor.cc', '_objref_' + name_interface + '::~_objref_' + name_interface)
                            
                            # Configuration de l'init
                            fichier_config_temp =  open('fichier_config_temp','wr')
                            s = 'METHOD_NAME=' + nom_methode_simple + '\n'
                            fichier_config_temp.write(s)
                            # Calcul du nombre d'arguments
                            nombre_argument = string.count(arguments, ',')
                            nombre_argument = nombre_argument + 1
                            s = 'ARGS_NUMBER=' + str(nombre_argument) + '\n'
                            fichier_config_temp.write(s)
                            fichier_config_temp.close()
                            base.file_configuration(fichier_source_cc,'fichier_config_temp')
                            os.remove('fichier_config_temp')
                            #
                            #fichier = open(fichier_source_cc,'r')
                            #for s in fichier.readlines():
                            #    print s
                            #fichier.close()
                            #
                            # Configuration de la methode init_Method_  + nom_methode_simple
                            # Remplacement du code de la methode
                            base.replace_code_cc(fichier_source_cc, chemin + '/ORB/OmniORB3/gen/Init_Method_Gen.cc', '_objref_' + name_interface + '::' + 'init_Method_' + nom_methode_simple + '(')
                            
                            # Creation du fichier de configuration de la methode et configuration
                            fichier_config_temp =  open('fichier_config_temp','wr')
                            s = 'METHOD_NAME=' + nom_methode_simple + '\n'
                            fichier_config_temp.write(s)
                            fichier_config_temp.close()
                            base.file_configuration(fichier_source_cc,'fichier_config_temp')
                            os.remove('fichier_config_temp')
                            
                            ################################################################

                            ################################################################
                            # Insertion du code dans le fichier_source_cc
                            
                            # Creation partie commune entre user et user_PaCoInit
                            # Cette partie concerne la connection du client avec l'input manager
                            # la creation des stubs + la creation des bibliotheques de redistributions
                            
                            fichier_config_temp =  open('fichier_config_temp','wr')
                            s = 'METHOD_NAME=' + nom_methode_simple + '\n'
                            fichier_config_temp.write(s)

                            # Creation de la chaine CREATION_BIB
                            nombre_argument = string.count(arguments, ',')
                            nombre_argument = nombre_argument + 1

                            creation_bib = ''
                            args = ''
                            init_args = ''
                            # Cette boucle analyse chaque argument
                            # on stocke dans creation_bib le code de creation des bibs
                            # on stocke dans args les noms des differents arguments
                            # on stocke dans init_args le code d'appel de redistributions des donnees
                            for compteur in range(1,nombre_argument+1):
                                # On cherche le type de la donnee
                                macro = 'ARG_' + name_interface + '_' + nom_methode_simple + '_' + str(compteur)
                                type_arg = base.search_macro(configfile,macro)

                                if type_arg == 'Replicated':
                                    index_temp = string.find(arguments, ',')
                                    if index_temp == -1:
                                        index2_temp = string.find(arguments, ')')
                                        index2_temp2 = string.rfind(arguments, ' ')
                                        chaine_temp = arguments[index2_temp2+1:index2_temp]
                                        args = args + chaine_temp
                                    else:
                                        arguments_temp = arguments[:index_temp]
                                        index_temp2 = string.rfind(arguments_temp, ' ')
                                        chaine_temp = arguments[index_temp2+1:index_temp]
                                        args = args + chaine_temp + ', '
                                        arguments = arguments[index_temp+1:]
                                else:
                                    index_temp = string.find(arguments, ',')
                                    chaine_temp = ''
                                    chaine_temp_type = ''
                                    if index_temp == -1:
                                        index2_temp = string.find(arguments, ')')
                                        index2_temp2 = string.rfind(arguments, ' ')
                                        # on recupere le type de l'argument
                                        chaine_temp_type_arg = arguments[:index2_temp2]
                                        index_debut_type_arg = string.rfind(chaine_temp_type_arg, ' ')
                                        chaine_temp_type = chaine_temp_type_arg[index_debut_type_arg+1:]
                                        chaine_temp_type = chaine_temp_type[:-1]
                                        # debug print type_arg
                                        # on recupere le nom de l'argument
                                        chaine_temp = arguments[index2_temp2+1:index2_temp]
                                        args = args + '*final_data_' + chaine_temp
                                        
                                    else:
                                        arguments_temp = arguments[:index_temp]
                                        index_temp2 = string.rfind(arguments_temp, ' ')
                                        # on recupere le type de l'argument
                                        chaine_temp_type_arg = arguments[:index2_temp2]
                                        index_debut_type_arg = string.rfind(chaine_temp_type_arg, ' ')
                                        chaine_temp_type = chaine_temp_type_arg[index_debut_type_arg+1:]
                                        chaine_temp_type = chaine_temp_type[:-1]
                                        # debug print type_arg
                                        # on recupere le nom de l'argument
                                        chaine_temp = arguments[index_temp2+1:index_temp]
                                        args = args + '*final_data_' + chaine_temp + ', '
                                        arguments = arguments[index_temp+1:]
                                        
                                    # creation_bib = creation_bib + 'METHOD_NAME_pt->libraries[' + str(compteur-1)  + '] = new DistributionLibrary_' + type_arg + '();\n'     
                                    # Code pour la methode name_ + 'PaCOInit'
                                    creation_bib = creation_bib + 'METHOD_NAME_pt->libraries[' + str(compteur-1)  + '] = new DistributionBlock();\n'
                                    # Code pour la methode
                                    init_args = init_args + name_interface + '_PaCO::PaCOData_' + chaine_temp + ' * final_data_' + chaine_temp +' = new ' + name_interface + '_PaCO::PaCOData_' + chaine_temp + ';\n'
                                    init_args = init_args + 'CORBA::Any an_any_' + chaine_temp + ';\n'
                                    # Code temporaire tant que la bib ne marche pas
                                    init_args = init_args + 'CORBA::Long l_' + chaine_temp + ' = 100;\n'
                                    init_args = init_args + 'final_data_' + chaine_temp + '->infos_desc <<= ' +  'l_' + chaine_temp + ';\n'
                                    init_args = init_args + 'final_data_' + chaine_temp + '->data.length(1);\n'
                                    init_args = init_args + 'final_data_' + chaine_temp + '->data[0] = *(new '+ chaine_temp_type + '('+chaine_temp+'));\n'
                                    
                                    init_args = init_args +  '// ' + nom_methode_simple + '_pt->libraries[' + str(compteur-1) + ']->compute((void*)&' + chaine_temp + ', '+ chaine_temp + '_PaCO);\n'
                                    
                                    # Ligne fausse !!
                                    #init_args = init_args + 'final_data_' + chaine_temp + '->data = ' + chaine_temp + '_PaCO;\n'
                            # print init_args
                            s = 'ARGS=' + args + '\n'
                            fichier_config_temp.write(s)
                            s = 'CREATION_BIB=' + creation_bib + '\n'
                            fichier_config_temp.write(s)
                            s = 'INTERFACE_NAME=' + name_interface + '\n'
                            fichier_config_temp.write(s)
                            #s = 'INIT=' + init_args + '\n'
                            #fichier_config_temp.write(s)
                            fichier_config_temp.close()

                            ####################################################################################################
                            # Insertion de la methode setMode
                            #fichier_temp = open('f','wr')
                            #s = 'METHOD_NAME=' + nom_methode_simple + '\n'
                            #fichier_temp.write(s)
                            #s = 'CLASS_NAME=' + '_objref_' + name_interface + '\n'
                            #fichier_temp.write(s)
                            #fichier_temp.close()
                            #base.concanate_files(fichier_source_cc,chemin + '/ORB/OmniORB3/gen/ClientSetModeGen.cc')
                            #base.file_configuration(fichier_source_cc,'fichier_config_temp')
                            #os.remove('f')
                            ####################################################################################################
                            # Insertion du code de user_PaCoInit
                            # Pour cela, il faut concaneter les deux fichiers CodeConnexionCommun.cc et PaCOInitCodeSpecifique.cc
                            fichier_temp_final = open('fichier_temp_final','a')
                            file1 = open(chemin + '/ORB/OmniORB3/gen/CodeConnexionCommun.cc','r')
                            file2 = open(chemin + '/ORB/OmniORB3/gen/PaCOInitCodeSpecifique.cc','r')
                            for ligne in file1.readlines():
                                fichier_temp_final.write(ligne)
                            for ligne2 in file2.readlines():
                                fichier_temp_final.write(ligne2)
                            file1.close()
                            file2.close()
                            fichier_temp_final.close()
                            base.replace_code_cc(fichier_source_cc, 'fichier_temp_final', '::' + nom_methode_simple + '_PaCOInit(')
                            base.file_configuration(fichier_source_cc,'fichier_config_temp')
                            # le deuxieme appel permet de configurer creation_bib
                            base.file_configuration(fichier_source_cc,'fichier_config_temp')
                            os.remove('fichier_temp_final')
                            ####################################################################################################

                            ####################################################################################################
                            # Insertion du code de user
                            # compilation de deux fichiers
                            fichier_temp_final = open('fichier_temp_final','a')
                            file1 = open(chemin + '/ORB/OmniORB3/gen/CodeConnexionCommun.cc','r')
                            file2 = open(chemin + '/ORB/OmniORB3/gen/MethodClientPart2Gen.cc','r')
                            for ligne in file1.readlines():
                                fichier_temp_final.write(ligne)
                            for ligne2 in file2.readlines():
                                fichier_temp_final.write(ligne2)
                            file1.close()
                            file2.close()
                            fichier_temp_final.close()
                            
                            base.replace_code_cc(fichier_source_cc, 'fichier_temp_final', nom_methode_complet)
                            base.file_configuration(fichier_source_cc,'fichier_config_temp')
                            # le deuxieme appel permet de configurer creation_bib
                            base.file_configuration(fichier_source_cc,'fichier_config_temp')
                            # recopie du fichier
                            fichier_copie = open('fichier_copie','wr')
                            fichier = open(fichier_source_cc,'r')
                            for s in fichier.readlines():
                                fichier_copie.write(s)
                            fichier.close()
                            fichier_copie.close()
                            base.replace_string('fichier_copie',fichier_source_cc,'INIT',init_args)

                            os.remove('fichier_copie')
                            os.remove('fichier_config_temp')
                            os.remove('fichier_temp_final')

def generate_servant(fichier_source_h, configfile, fichier_servant_h, fichier_servant_c, fichier_orb_h):

    # init de base
    chemin = os.environ['PACOPATH']
    orb = base.search_macro(configfile,'ORB')
    numero_interface = 0
    continu = 'true'

    # On commence par creer les deux fichiers et faire une premiere initialisation des fichiers a inclure
    # Creation
    fichier_h = open(fichier_servant_h,'wr')
    fichier_h.close()
    fichier_c = open(fichier_servant_c,'wr')
    fichier_c.close()
    # Configuration
    # Pour le .h
    # FILE_TO_INCLUDE
    base.replace_string(chemin + '/ORB/OmniORB3/gen/ServantParallelGenInclude.hh',fichier_servant_h,'FILE_TO_INCLUDE',fichier_orb_h)
    # Pour le .cc
    # FILE_TO_INCLUDE
    base.replace_string(chemin + '/ORB/OmniORB3/gen/ServantParallelGenInclude.cc',fichier_servant_c,'FILE_TO_INCLUDE',fichier_servant_h)
    # choix de l'orb
    if orb == 'OMNIORB3':
        # Pour chaque interface parallele, on ajoute la definition du servant appropiee
        while continu == 'true':
            numero_interface = numero_interface + 1
            name_interface = base.search_macro(configfile,'INTERFACE_NAME_' + str(numero_interface))
            if name_interface == 'null':
                continu = 'false'
            else:
                ###########################################################################
                # On commence par le .h

                # On rajoute une nouvelle definition d'un servant dans le .h
                fichier_h = open(fichier_servant_h,'r')
                fichier_a_ajouter = open(chemin + '/ORB/OmniORB3/gen/ServantParallelGen.hh','r')
                fichier_a_configurer = open('fichier_a_configurer','wr')

                for s in fichier_h.readlines():
                    fichier_a_configurer.write(s)
                for s in fichier_a_ajouter.readlines():
                    fichier_a_configurer.write(s)
                
                fichier_a_ajouter.close()
                fichier_h.close()
                fichier_a_configurer.close()
                
                # Il maintenant configurer le nouveau fichier h
                fichier_config = open('fichier_config','wr')

                # FILE_TO_INCLUDE
                s = 'FILE_TO_INCLUDE=' + fichier_orb_h + '\n'
                fichier_config.write(s)

                # NAME_INTERFACE
                s = 'NAME_INTERFACE=' + name_interface + '\n'
                fichier_config.write(s)

                # NAME_CLASS
                package_name = base.search_macro(configfile,'PACKAGE_NAME_' + str(numero_interface))
                if package_name != '':
                    s = 'NAME_CLASS=' + 'POA_'+ package_name[2:] + '::' + name_interface + '_PaCO\n'
                else:
                    s = 'NAME_CLASS=' + 'POA_' + name_interface + '_PaCO\n'
                fichier_config.write(s)

                # INSERT_METHOD + STRUCTS
                # Il faut ici ne rajouter que les methodes parallles
                # Pour chaque methode parallele, on lui associe une structure qui lui est propre
                name_class_search = '_impl_' + name_interface + '_PaCO'
                insert_method_class = base.search_method(fichier_source_h,name_class_search,'OMNIORB3')
                
                nombre_interface = 0
                s1 = ''
                s2 = ''
                s3 = ''
                s4 = ''
                # Test de chaque methode
                for counter in range(len(insert_method_class)):
                    if counter != 0:
                        # elimination du virtual
                        chaine = insert_method_class[counter]
                        fin_virtual = string.find(chaine,'virtual ')
                        chaine = chaine[fin_virtual+8:]

                        # pt dans le nom
                        fin_return = string.find(chaine,' ')
                        fin_def = string.find(chaine,';')
                        fin_nom = string.find(chaine,'(')

                        # differentes chaines
                        retour =  chaine[:fin_return]
                        nom_methode_complet = chaine[fin_return+1:fin_def]
                        nom_methode_simple = chaine[fin_return+1:fin_nom]
                        arguments = chaine[fin_nom:]
                        
                        # identification du type de la methode
                        type = base.search_macro(configfile,'TYPE_' + name_interface + '_' + nom_methode_simple)
                        ########### On n'insere que les methodes parallles !!! ###########################
                        if type == 'distributed':
                            # Methode _PaCO
                            nombre_interface = nombre_interface + 1
                            s1 = s1 + 'INSERT_METHOD_' + str(nombre_interface) + '\n'
                            s2 = s2 + 'INSERT_METHOD_' +str(nombre_interface) + '=' + retour + ' ' + nom_methode_simple + '_PaCO' + arguments + ';\n'   
                            s3 = s3 + 'STRUCT_' + str(nombre_interface) + '\n'
                            s4 = s4 + 'STRUCT_' + str(nombre_interface) + '=' + nom_methode_simple + '\n'
                            
                            # Rajout de la methode _end()
                            nombre_interface = nombre_interface + 1
                            s1 = s1 + 'INSERT_METHOD_' + str(nombre_interface) + '\n'
                            s2 = s2 + 'INSERT_METHOD_' +str(nombre_interface)+ '='+ 'void '+ nom_methode_simple + '_end();\n'

                fichier_config.write(s2)
                fichier_config.write(s4)
                fichier_config.close()
                
                # Configuration du fichier_h
                base.replace_string('fichier_a_configurer',fichier_servant_h,'INSERT_METHOD',s1)

                # mise a jour du fichier_a_configurer
                fichier_h = open(fichier_servant_h,'r')
                fichier_a_configurer = open('fichier_a_configurer','wr')
                for s in fichier_h.readlines():
                    fichier_a_configurer.write(s)
                fichier_h.close()
                fichier_a_configurer.close()

                base.replace_string('fichier_a_configurer',fichier_servant_h,'STRUCTS',s3)

                # mise a jour du fichier_a_configurer
                fichier_h = open(fichier_servant_h,'r')
                fichier_a_configurer = open('fichier_a_configurer','wr')
                for s in fichier_h.readlines():
                    fichier_a_configurer.write(s)
                fichier_h.close()
                fichier_a_configurer.close()
                
                # Pour les structures la methode file_configuration ne suffit pas.
                # C'est pourquoi on le fait a moitie a la main ici
                fichier_struct_temp = open('fichier_struct_temp','wr')
                fichier_struct_temp.close()
                while nombre_interface != 0:
                    nombre_interface = nombre_interface - 1
                    method_name = base.search_macro('fichier_config', 'STRUCT_' + str(nombre_interface))
                    if method_name != 'null':
                        s_temp = ''
                        base.replace_string(chemin + '/ORB/OmniORB3/gen/StructServantGen.hh','fichier_struct_temp','METHOD_NAME',method_name)
                        fichier_struct = open('fichier_struct_temp','r')
                        for s in fichier_struct.readlines():
                            s_temp = s_temp + s
                        fichier_struct.close()
                        base.replace_string('fichier_a_configurer',fichier_servant_h,'STRUCT_' + str(nombre_interface) ,s_temp)
                        # mise a jour du fichier_a_configurer
                        fichier_h = open(fichier_servant_h,'r')
                        fichier_a_configurer = open('fichier_a_configurer','wr')
                        for s in fichier_h.readlines():
                            fichier_a_configurer.write(s)
                        fichier_h.close()
                        fichier_a_configurer.close()
                
                base.file_configuration(fichier_servant_h,'fichier_config')
                os.remove('fichier_config')
                os.remove('fichier_a_configurer')
                os.remove('fichier_struct_temp')

                ################################################################################
                ################################################################################
                # On continu par le fichier .cc

                ################################################################################
                # On commence par le constructeur et le destructeur
                # Pour cela on commence par rajouter le fichier de definition des constructeurs
                base.concanate_files(fichier_servant_c,chemin + '/ORB/OmniORB3/gen/ServantParallelGenConstructors.cc')

                # Configuration
                fichier_config = open('fichier_config','wr')

                # FILE_TO_INCLUDE
                s = 'NAME_INTERFACE=' + name_interface + '\n'
                fichier_config.write(s)
                
                fichier_config.close()
                base.file_configuration(fichier_servant_c,'fichier_config')
                os.remove('fichier_config')
                ################################################################################

                ################################################################################
                # Maintenant pour chaque operation parallele, nous allons configurer les constructeurs
                # puis ajouter les definitions des methodes
                
                name_class_search = '_impl_' + name_interface + '_PaCO'
                insert_method_class = base.search_method(fichier_source_h,name_class_search,'OMNIORB3')
                
                nombre_interface = 0
                init_method = ''
                # Test de chaque methode
                for counter in range(len(insert_method_class)):
                    if counter != 0:
                        # elimination du virtual
                        chaine = insert_method_class[counter]
                        fin_virtual = string.find(chaine,'virtual ')
                        chaine = chaine[fin_virtual+8:]

                        # pt dans le nom
                        fin_return = string.find(chaine,' ')
                        fin_def = string.find(chaine,';')
                        fin_nom = string.find(chaine,'(')

                        # differentes chaines
                        retour =  chaine[:fin_return]
                        nom_methode_complet = chaine[fin_return+1:fin_def]
                        nom_methode_simple = chaine[fin_return+1:fin_nom]
                        arguments = chaine[fin_nom:]
                        
                        # identification du type de la methode
                        type = base.search_macro(configfile,'TYPE_' + name_interface + '_' + nom_methode_simple)
                        if type == 'distributed':
                            # Traitement pour la methode _PaCO
                            
                            ################################################################################
                            # Constructeurs
                            # Insertion des codes
                            base.insert_code_cc(fichier_servant_c, chemin + '/ORB/OmniORB3/gen/StructServantGenConstructor.cc', name_interface + '_serv::' + name_interface + '_serv')
                            base.insert_code_cc(fichier_servant_c, chemin + '/ORB/OmniORB3/gen/StructServantGenDestructor.cc', name_interface + '_serv::~' + name_interface + '_serv')
                            # Configuration
                            fichier_config_temp =  open('fichier_config_temp','wr')
                            s = 'METHOD_NAME=' + nom_methode_simple + '\n'
                            fichier_config_temp.write(s)
                            # Calcul du nombre d'arguments
                            nombre_argument = string.count(arguments, ',')
                            nombre_argument = nombre_argument + 1
                            s = 'ARGS_NUMBER=' + str(nombre_argument) + '\n'
                            fichier_config_temp.write(s)
                            fichier_config_temp.close()
                            base.file_configuration(fichier_servant_c,'fichier_config_temp')
                            os.remove('fichier_config_temp')
                            ################################################################################
                            
                            ################################################################################
                            # Methode _PaCO et _end
                            # Insertion du code generique
                            base.concanate_files(fichier_servant_c,chemin + '/ORB/OmniORB3/gen/ServantParallelGenOperation.cc')

                            # Il faut maintenant configurer le fichier
                            fichier_config = open('fichier_config','wr')

                            # NAME_INTERFACE
                            s = 'NAME_INTERFACE=' + name_interface + '\n'
                            fichier_config.write(s)
                            
                            # NAME_OPERATION_COMPLETE
                            s = 'NAME_OPERATION_COMPLETE=' + nom_methode_simple + '_PaCO' + arguments[:-2] + '\n'
                            fichier_config.write(s)

                            # NAME_FINAL
                            s = 'NAME_FINAL=' + nom_methode_simple + '\n'
                            fichier_config.write(s)

                            # NAME_END
                            s = 'NAME_END=' + nom_methode_simple + '_end()\n'
                            fichier_config.write(s)

                            # METHOD_NAME
                            s = 'METHOD_NAME=' + nom_methode_simple + '\n'
                            fichier_config.write(s)
                            
                            # COMPUTE
                            # Compute necessite d'avoir la connaissance sur le type des arguments
                            # Creation de la chaine CREATION_BIB
                            
                            compute = ''
                            args = ''

                            init_method = nom_methode_simple + '_pt->libraries = new (DistributionBlock*)[' + nom_methode_simple + '_pt->number_arguments];\n'
                            
                            # Cette boucle analyse chaque argument
                            # on stocke dans compute le code de creation et de gestion des arguments
                            # on stocke dans args les noms des differents arguments finaux
                            for compteur in range(1,nombre_argument+1):
                                # On cherche le type de la donnee
                                macro = 'ARG_' + name_interface + '_' + nom_methode_simple + '_' + str(compteur)
                                type_arg = base.search_macro(configfile,macro)

                                if type_arg == 'Replicated':
                                    index_temp = string.find(arguments, ',')
                                    if index_temp == -1:
                                        index2_temp = string.find(arguments, ')')
                                        index2_temp2 = string.rfind(arguments, ' ')
                                        chaine_temp = arguments[index2_temp2+1:index2_temp]
                                        args = args + chaine_temp
                                    else:
                                        arguments_temp = arguments[:index_temp]
                                        index_temp2 = string.rfind(arguments_temp, ' ')
                                        chaine_temp = arguments[index_temp2+1:index_temp]
                                        args = args + chaine_temp + ', '
                                        arguments = arguments[index_temp+1:]
                                else:
                                    index_temp = string.find(arguments, ',')
                                    chaine_temp = ''
                                    type = ''
                                    if index_temp == -1:
                                        index2_temp = string.find(arguments, ')')
                                        index2_temp2 = string.rfind(arguments, ' ')
                                        chaine_temp = arguments[index2_temp2+1:index2_temp]
                                        #args = args +  '*' + chaine_temp + '_final'
                                        args = args   + chaine_temp
                                        type = arguments[1:index2_temp2]
                                    else:
                                        arguments_temp = arguments[:index_temp]
                                        index_temp2 = string.rfind(arguments_temp, ' ')
                                        chaine_temp = arguments[index_temp2+1:index_temp]
                                        # bug bib
                                        # args = args + '*' + chaine_temp + '_final' + ', '
                                        args = args   + chaine_temp + ', '
                                        type = arguments[1:index_temp2]
                                        arguments = arguments[index_temp+1:]

                                    # il faut d'abord analiser le type pour enlever le & et les const possibles
                                    # le const
                                    index_temp = string.find(type, 'const ')
                                    if index_temp != -1:
                                        type = type[index_temp+6:]
                                    # le &
                                    index_temp = string.find(type, '&')
                                    if index_temp != -1:
                                        type = type[:index_temp]
                                    # Code pour la methode
                                    compute = compute + '  ' + type + ' * ' + chaine_temp + '_final;\n'
                                    compute = compute + '  // temp = ' + nom_methode_simple + '_pt->libraries[' + str(compteur-1) + ']->serveur_compute((void*)&' + chaine_temp + ', (void*)&'+ chaine_temp +'_final);\n'
                                    compute = compute + '  temp = true;\n'
                                    compute = compute + '  if (temp == true) data_complete = temp;\n'

                                    # Code pour init_method
                                    
                                    init_method = init_method + nom_methode_simple + '_pt->libraries[' + str(compteur-1) + '] = new DistributionBlock();\n'

                            # ARGS
                            s = 'ARGS=' + args + '\n'
                            fichier_config.write(s)

                            fichier_config.close()
                            base.file_configuration(fichier_servant_c,'fichier_config')
                            os.remove('fichier_config')

                            # cas du compute
                            # different car compute sur plusieurs lignes
                            
                            fichier_c = open(fichier_servant_c,'r')
                            fichier_a_configurer = open('fichier_a_configurer','wr')
                            for s in fichier_c.readlines():
                                fichier_a_configurer.write(s)
                            fichier_c.close()
                            fichier_a_configurer.close()

                            base.replace_string('fichier_a_configurer',fichier_servant_c,'COMPUTE',compute)
                            os.remove('fichier_a_configurer')
                            
                # Ajout de la methode init_InterfaceParallel
                # Insertion du code generique
                base.concanate_files(fichier_servant_c,chemin + '/ORB/OmniORB3/gen/ServantParallelGenInitOperation.cc')

                # configuration
                fichier_config = open('fichier_config','wr')
                
                # NAME_INTERFACE
                s = 'NAME_INTERFACE=' + name_interface + '\n'
                fichier_config.write(s)

                # INIT_METHOD
                # s= 'INIT_METHOD=' + init_method + '\n'
                # fichier_config.write(s)
                fichier_config.close()
                base.file_configuration(fichier_servant_c,'fichier_config')

                # INIT_METHOD
                # Comme init_method fait plus d'une ligne, il faut utiliser un autre moyen
                # recopie du fichier
                fichier_copie = open('fichier_copie','wr')
                fichier = open(fichier_servant_c,'r')
                for s in fichier.readlines():
                    fichier_copie.write(s)
                fichier.close()
                fichier_copie.close()
                base.replace_string('fichier_copie',fichier_servant_c,'INIT_METHOD',init_method)
                os.remove('fichier_copie')
                os.remove('fichier_config')
                ################################################################################
                
