#!/usr/bin/env python
# Written by Andre Ribes 2002

import sys
import os
import string
import base
import UpgradeIdl
import Proxy
import Context
import Client
import Server
import complex

# Uses Corba compiler for generating the corba stubs
def CreateStub(orb_name, idl2_file):
    command =  complex.orb_carac("COMMAND_LINE", orb_name)+ " " + idl2_file
    os.system(command)
    name_files = '.h;.cc'
    return name_files

def main():
    if len(sys.argv) < 4:
        print 'Error four arguments: <idl2 file>, <configuration_file>, <debug>, optional <modes>'
        sys.exit(0)

    modes = []
    idl2file = sys.argv[1]
    configfile = sys.argv[2]
    debug = sys.argv[3]
    if len(sys.argv) >= 4:
	for compteur in range(4, len(sys.argv)) :
	    modes.append(sys.argv[compteur])
    if debug == '1':
	print "Modes : "
	print modes

    orb = base.search_macro(configfile,'ORB')

    # Adding parallel arguments and types into
    # the Idl definition
    print('Upgrading Idl file')
    base.create_file('include')
    UpgradeIdl.Upgrade_nom(idl2file, configfile, 'no')
    UpgradeIdl.Upgrade_nom(idl2file, configfile + '_return', 'yes')
    include_inserted = []                  
    name = UpgradeIdl.Upgrade(idl2file, configfile, include_inserted)
    base.TwinFile(name, idl2file)
    name = UpgradeIdl.Upgrade(idl2file, configfile + '_return', include_inserted)
    base.concanate_files('include',name)

    print('Generating CORBA stubs')
    base.TwinFile('include', idl2file)
    Names = CreateStub(orb, idl2file)
    
    temp = string.find(idl2file,'.idl')
    temp2 = string.find(Names,';')
    fichier_source_h = idl2file[:temp] + Names[:temp2]
    fichier_source_cc = idl2file[:temp] + Names[temp2 + 1:]
     
    print('Generating proxies')
    print('WARNING : OuputManager is not implemented !')
    # Interface Manager
    Proxy.GenerateInterfaceManager(fichier_source_h, configfile, idl2file[:temp], modes,"server", debug)
    # Nouvelle Remarque : le proxy devient un client comme un autre
    # Dans ce cas pourquoi generer deux fois la meme chose ???
    # Il vaut mieux utiliser les informations du cote client
    
    # Partie pour le "client" du proxy : il faut donc un context + un proxy + le servant pour le retour du client
    # Proxy.GenerateInterfaceManager(fichier_source_h, configfile + '_return', idl2file[:temp], modes,"server_return", debug)
    # Context.GenerateClientContext(fichier_source_h, fichier_source_cc, configfile, idl2file[:temp], modes,'1', debug)
    # Server.GenerateServant_Return(fichier_source_h, configfile + '_return', idl2file[:temp], modes, debug,'1')

    # PaCO++ stubs generation
    print('Generating client part')
    # Return server proxy
    Proxy.GenerateInterfaceManager(fichier_source_h, configfile + '_return', idl2file[:temp], modes,"client", debug)
    Context.GenerateClientContext(fichier_source_h, fichier_source_cc, configfile, idl2file[:temp], modes,'0', debug)
    Client.GenerateClientStub(fichier_source_h, fichier_source_cc, configfile, idl2file[:temp], modes, debug)
    Server.GenerateServant_Return(fichier_source_h, configfile + '_return', idl2file[:temp], modes, debug,'0')
    print('Generating server part')
    Context.GenerateServeurContext(fichier_source_h, fichier_source_cc, configfile, idl2file[:temp], modes, debug)
    Server.GenerateServantStub(fichier_source_h, configfile, idl2file[:temp], modes, debug)
    Client.GenerateClientStub_Return(fichier_source_h, fichier_source_cc, configfile + '_return', idl2file[:temp], modes, debug)

    
    if sys.argv[3] == '0':
        # Delete temporary files
        os.remove('idl_nom')
        os.remove('include')
        os.remove('idl_temp_final')
        os.remove('configuration_file')
        os.remove('configuration_file_return')
main()


