# Written by Andre Ribes 2002
#!/usr/bin/env python

import os
import sys
import string
import base
import complex

# Upgrade permet d'inserer la definition des differentes structures de parallelisme
# Arg_1 : le fichier idl2 a upgrader
# Arg_2 : le fichier de configuration associe
# Retour : Retourne un nouveau fichier idl2
def Upgrade_nom(idl2file, configfile, second):
    
    #####################################################################
    # Init
    PaCOPath = os.environ['PACOPATH']
    name_interface = ''
    name_module = ''
    complete_name = ''
    numero_interface = 0
    continu = 'true'
    # fichier_idl = open(idl2file, 'r')
    # Le fichier idl_nom contient des informations sur les arguments pour la
    # generation de la version finale Idl2
    if second == 'no':
        fichier_temp_nom = open('idl_nom','wr')
        fichier_temp_nom.write('debut' + '\n')
        fichier_temp_nom.close()

    #
    #####################################################################

    #####################################################################
    # faire ce travail pour chaque interface dans le fichier de configuration
    while continu == 'true':
        #####################################################################
        # Recherche de la nouvelle interface a traite
        fichier_idl = open(idl2file, 'r')
        numero_interface = numero_interface + 1
        name_interface = base.search_macro(configfile,'INTERFACE_NAME_' + str(numero_interface))
        name_module = base.search_macro(configfile,'PACKAGE_NAME_' + str(numero_interface))
        complete_name = name_module +'::'+ name_interface
        search_macro_package_name = name_module
        name_module = name_module[2:]

        # Test sur le nom de l'interface
        if name_interface == 'null':
            continu = 'false' # On sort de la boucle et on termine la fonction
        #
        #####################################################################
        # On commence l'analyse
        else:
            #####################################################################
            # Premiere etape, on recherche pour chaque interface parallele
            # les types des arguments distribues
            # On recherche ensuite si ce type est un type supporte par PaCO++
            # Algo : module -> interface -> arguments
            etape = 'Module'
            index = string.find(name_module, '::')
            if index == -1:
                etape = 'Interfaces'
            else:
                module_search = name_module[:index]
                name_module = name_module[index+2:]
            for s in fichier_idl.readlines():
                #####################################################################
                # On cherche a descendre dans le bon module
                if etape == 'Module':
                    index = string.find(s,'module ' + module_search)
                    if index != -1:
                        index = string.find(name_module, '::')
                        if index == -1:
                            etape = 'Interfaces'
                        else:
                            module_search = name_module[:index]
                            name_module = name_module[index+2:]
                #
                #####################################################################
                # On cherche a descendre dans la bonne interface
                elif etape == 'Interfaces':
                    index = string.find(s,'interface ' + name_interface)
                    if index != -1:
                        etape = 'Arguments'
                #
                #####################################################################
                #
                elif etape == 'Arguments':
                    index = string.find(s,');')
                    if index != -1:
                        # On a trouve une operation !
                        index = string.find(s,'(')
                        # On recupere les arguments
                        s_args = s[index+2:-3]
                        # On cherche le nom de l'operation
                        s = s[:index]
                        index = string.rfind(s,' ')
                        if index == -1:
                            print('ERROR : IDL2 File format not correct !! ERROR')
                            sys.exit(0)
                        else:
                            s = s[index+1:]
                            type_method = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + name_interface + '_' + s)
                            if type_method == 'distributed':
                                Arret = 'false'
                                while Arret == 'false':
                                    result = complex.researchArgName(s_args, 'idl')
                                    arg_idl = result.pop()
                                    arg_type = result.pop()
                                    arg_name = result.pop()
                                    s_args = result.pop()
                                    macro = 'ARG_'  + search_macro_package_name + '_' + name_interface + '_' + s + '_' + arg_name
                                    type_arg =  base.search_macro(configfile,macro)
                                    if type_arg == 'null':
                                        Arret = 'true'
                                    elif type_arg == 'Distributed':
                                        # Attention pour l'instant, on ne supporte que des sequences ou
                                        # des sequences de sequences
                                        # Analyse de types_arg
                                        # S'il y a un module, le type est declare ailleurs
                                        # Sinon il est declare dans l'interface
                                        types_arg = arg_type
                                        type_final = types_arg
                                        type_final_seq = ''
                                        index = string.find(types_arg,'::')
                                        if index == -1:
                                            type_final_seq = search_type_seq(idl2file, complete_name, types_arg)
                                        else:
                                            index = string.rfind(types_arg,'::')
                                            type_final_seq = search_type_seq(idl2file, types_arg[:index], types_arg[index+2:])

                                        fichier_temp_nom = open('idl_nom','a+')
                                        # Rustine : on enleve les :: on debut de complete_name
                                        fichier_temp_nom.write('ARG_TYPE_' + complete_name[2:] + '_' + s + '_' + arg_name + '=' + type_final +'\n')
                                        fichier_temp_nom.write('ARG_TYPE_SEQ_' + complete_name[2:] + '_' + s + '_' + arg_name + '=' + type_final_seq +'\n')
                                        fichier_temp_nom.close()
                    else:
                        # Fin de l'interface ??
                        # On ne peut utiliser }; comme delimiteur
                        # puisque l'on peut definir des structures qui mettent
                        # des }; dans la definition de l'interface
                        index = string.find(s,'interface')
                        if index != -1:
                            break
                        index = string.find(s,'module')
                        if index != -1:
                            break
    fichier_idl.close()
                #
    #################################################################################
def Upgrade(idl2file, configfile, include_inserted):
    PaCOPath = os.environ['PACOPATH']
     
    #################################################################################            
    # Nouvelle etape, il faut maintenant inserer dans les interfaces _PaCO
    # les differentes structures
    #####################################################################
    # Init
    # Le fichier idl_temp_final contient la version Idl2
    fichier_temp_final =  open('idl_temp_final','wr')
    fichier_temp =  open('idl_temp','wr')
    fichier_temp.close()
    fichier_idl = open(idl2file, 'r')
    for s in fichier_idl.readlines():
        fichier_temp_final.write(s)
    fichier_idl.close()
    fichier_temp_final.close()
    name_interface = ''
    name_module = ''
    complete_name = ''
    numero_interface = 0
    continu = 'true'
    while continu == 'true':
        #####################################################################
        # Recherche de la nouvelle interface a traite
        numero_interface = numero_interface + 1
        name_interface = base.search_macro(configfile,'INTERFACE_NAME_' + str(numero_interface))
        name_module = base.search_macro(configfile,'PACKAGE_NAME_' + str(numero_interface))
        # On elimine les ::
        complete_name = name_module +'::'+ name_interface
        search_macro_package_name = name_module
        name_module = name_module[2:]
        # Test sur le nom de l'interface
        if name_interface == 'null':
            continu = 'false' # On sort de la boucle et on termine la fonction
        #
        #####################################################################
        # On commence l'analyse
        else:
            #####################################################################
            # Deuxieme etape, on recherche chaque interface _PaCO et on insere la
            # bonne structure
            # Algo : Module -> Interface -> Insertion

            # On commence par copier le fichier final dans le fichier temp
            fichier_temp_final =  open('idl_temp_final','r')
            fichier_temp =  open('idl_temp','wr')
            for s in fichier_temp_final.readlines():
                fichier_temp.write(s)
            fichier_temp.close()
            fichier_temp_final.close()

            # On travaille sur fichier_temp et on ecrit dans fichier_temp_final
            fichier_temp = open('idl_temp','r')
            fichier_temp_final = open('idl_temp_final','wr')
            etape = 'Module'
            index = string.find(name_module, '::')
            if index == -1:
                etape = 'Interfaces'
            else:
                module_search = name_module[:index]
                name_module = name_module[index+2:]
            for s in fichier_temp.readlines():
                #####################################################################
                # On cherche a descendre dans le bon module
                if etape == 'Module':
                    fichier_temp_final.write(s)
                    index = string.find(s,'module ' + module_search)
                    if index != -1:
                        index = string.find(name_module, '::')
                        if index == -1:
                            etape = 'Interfaces'
                        else:
                            module_search = name_module[:index]
                            name_module = name_module[index+2:]
                #
                #####################################################################
                # On cherche a descendre dans la bonne interface
                elif etape == 'Interfaces':
                    fichier_temp_final.write(s)
                    index = string.find(s,'interface ' + name_interface + '_PaCO')
                    if index != -1:
                        etape = 'Insertion'
                #
                #####################################################################
                # Modification de l'interface
                elif etape == 'Insertion':
                    # Il faut tester si on arrive a la fin de l'interface !!!!
                    index_interface = string.find(s,'interface ')
                    if index_interface != -1:
                        # Fin de l'interface puisque debut d'une autre !!!
                        etape = 'Fin'
                    # Detection d'une methode 
                    index = string.find(s,');')
                    if index == -1:
                        fichier_temp_final.write(s)
                    else:
                        
                        #####################################################################
                        # La chaine s represente la methode parallele
                        # Il faut pour chaque argument distribue:
                        # 1 : Inserer la description du nouveau type de la donnee
                        # 2 : Modifier le nom du type de l'argument dans la declaration de la methode

                        s_new = '' # Cette chaine represente la nouvelle declaration de la methode
                        method_name = ''
                        arguments = ''
                        numero_argument = 0
                        s_sauv = s
                        result = complex.decompose_method(s,'idl')
                        s_new = result.pop()
                        method_name = result.pop()
                        s_new = s_new + ' ' + method_name
                        arguments = result.pop()
                        argument_dis = 'false' # If there is an distributed argument, we remove the oneway ... HACK !!!!
                        # Methode parallele ???
                        # Attention on ne travaille que sur les methodes PaCO !
                        index = string.find(method_name, '_PaCO')
                        if index == -1 :
                            method_name = ''
                        else :
                            method_name = method_name[:-5]

                        method_type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' +  name_interface + '_' + method_name)
                        if method_type != 'distributed' :
                            s_new = s_new + arguments

			else :
                            # Pour chaque argument ...
#			    print "Methode parallele : " + arguments
                            while arguments != '':
#				print "Arguments restant : " + arguments
                                result = complex.researchArgName(arguments, 'idl')
                                arg_idl = result.pop()
                                arg_type = result.pop()
                                arg_name = result.pop()
                                arguments = result.pop()
                                arg_descr_type = ''
                                numero_argument = numero_argument + 1

                                macro = 'ARG_'  + search_macro_package_name + '_' + name_interface + '_' + method_name + '_' + arg_name
                                type_dis_arg =  base.search_macro(configfile,macro)
#				print "Argument actuel : " + arg_idl + " " + arg_type + ' ' + arg_name + ' ' + type_dis_arg
                                if numero_argument > 1 :
                                    s_new = s_new + ', '
                                else :
                                    s_new = s_new + '('

                                if type_dis_arg == 'Distributed':
                                    argument_dis = 'true'
                                    dis_arg_descr = base.search_macro(PaCOPath + '/GenFiles/Idl/GenType.idl', '@@GEN_DATA@@')
                                    LibDisType = base.search_macro(configfile,'ARG_DIS_TYPE_'  + search_macro_package_name + '_' + name_interface + '_' + method_name + '_' + arg_name)
                                    arg_type_to_get = base.search_macro(PaCOPath + '/DistributionLibraries/Types/' + LibDisType + '.cfg', '@@ARG_TYPE@@')
                                    arg_descr_type  = base.search_macro(PaCOPath + '/DistributionLibraries/Types/' + LibDisType + '.cfg', '@@DESCR_IDL@@')
                                    descr = base.search_macro(PaCOPath + '/DistributionLibraries/Types/' + LibDisType + '.cfg', '@@DESCR@@')
                                    if descr != 'corba' :
					have_to_be_included = 'true'
					for bib in include_inserted :
					    if bib == descr :
						have_to_be_included = 'false'
					if have_to_be_included == 'true':
					    base.add_include('include',PaCOPath + '/DistributionLibraries/Types/' + descr)
					    include_inserted.append(descr)
                                    arg_type = base.search_macro('idl_nom', arg_type_to_get + complete_name[2:] + '_' + method_name + '_' + arg_name)
                                    dis_arg_descr = base.string_configuration(dis_arg_descr, '@@ARG_TYPE@@', arg_type)
                                    dis_arg_descr = base.string_configuration(dis_arg_descr, '@@ARG_NAME@@', arg_name)
                                    fichier_temp_final.write(dis_arg_descr + '\n')                                    
				    s_new = s_new + arg_idl + ' distData_' + arg_name + '_t distData_' + arg_name + ', in ' + arg_descr_type + ' descr_' + arg_name
                                else :
                                    if arg_name != '':
                                        s_new = s_new + arg_idl + ' ' + arg_type + ' ' + arg_name
                            # Multiple Client patch
                            client_id = 'in short client_id'
                            if s_new[-1:] == '(' :
                                s_new = s_new + client_id
                            else :
                                s_new = s_new + ', ' + client_id
                            # End multiple Client patch
                            s_new = s_new + ');\n'
                            if argument_dis == 'true' :
                                index_arg_dis = string.find(s_new, 'oneway')
                                s_new = s_new[index_arg_dis+6:]
                
                        fichier_temp_final.write(s_new)
#                        index_hack = string.find(name_interface, '_Return')
#			index_hack_2 = string.find(name_interface, '_Return_PaCO')
#			print "Interface name : " + name_interface
#			print "s_new : " + s_new
#			print "s_sauv : " + s_sauv
#                        if index_hack == -1:
#                            fichier_temp_final.write(s_new)
#                        elif index_hack_2 != -1:
#			    fichier_temp_final.write(s_new)
#			else :
#			    fichier_temp_final.write(s_sauv)

                        
                #
                #
                #####################################################################
                # On finit d'ecrire le fichier

                elif etape == 'Fin':
                    fichier_temp_final.write(s)
            fichier_temp.close()
            fichier_temp_final.close()
    os.remove('idl_temp')   
    return 'idl_temp_final'
    
# search_type_seq permet de chercher le type d'un argument dans le cas d'une sequence
# null si pas sequence<T> sinon renvoi T
# Arg_1 : le fichier idl2
# Arg_2 : l'endroit ou se trouve le type
# Arg_3 : le nom du type
# Retour : On retourne le type de la sequence ou Unknown si la fonction n'a pas trouve de type
def search_type_seq(idl2file, empl, name):
    
    ###################################################################
    # elimination des :: au debut de complete_name de la forme ::T::T
    retour = 'Unknown'
    complete_name = empl[2:]
    fichier = open(idl2file,'r')
    etape = 'cherche interface'
    nom_interface = ''
    nom_module = ''
    # nom module a chercher
    index = string.find(complete_name,'::')
    if index == -1:
        etape = 'cherche definition'
        nom_interface = complete_name
    else:
        nom_module = complete_name[:index]
        complete_name = complete_name[index+2:]
    for s in fichier.readlines():
        if etape == 'cherche interface':
            index = string.find(s,'module ' + nom_module)
            # Ce qui veut dire module trouve
            if index != -1:
                index = string.find(complete_name,'::')
                if index == -1:
                    etape = 'cherche definition'
                    nom_interface = complete_name
                else:
                    nom_module = complete_name[:index]
                    complete_name = complete_name[index+2:]
        if etape == 'cherche definition':
            index = string.find(s,'typedef ')
            if index != -1:
                index2 = string.find(s,' ' + name + ';')
                if index2 != -1:
                    index3 = string.find(s, 'sequence<')
                    if index3 != -1:
                        index4 = string.find(s, '>')
                        retour = s[index3+9:index4]
                    else:
                        print 'Type n\'est pas une sequence'
    return retour

